(require  (lib "compile.ss" "dynext")
          (lib "link.ss" "dynext")
          (lib "file.ss" "dynext") 
          (lib "file.ss")
          (lib "pregexp.ss")
          (lib "pack.ss" "setup")
          "spico-strings.ss")

(define (warn . all)
  (for-each display all))

(define spico-version "1.8.1")
(define (get-os-name)
  (let ((path (system-library-subpath)))
    (regexp-replace* "/|\\\\" path "-")))
(define os (get-os-name))
(define install? #t)
(define spico-plt (string-append spico-name "-" spico-version "-" os "-" (version) ".plt"))
(define extra-sources '("info.ss" "lexer.ss" "spico-eval.ss" "spico-lang.ss" "spico-strings.ss" "spico-icon.png"))

(define srcs 
  '( "PicoEnv.c" 
     "PicoMai.c" 
     "PicoNat.c" 
     "PicoRea.c" 
     "PicoEva.c" 
     "PicoMem.c" 
     "PicoPri.c" 
     "PicoSca.c" 
     "spico.c"
     "seval.c")) 

(define objs (map (lambda (src) 
                    (append-object-suffix (extract-base-filename/c src))) 
                  srcs))

(when (eq? (system-type) 'windows) 
  ;; Add debugging flags: 
  (current-extension-compiler-flags
   (cons "/Zi" (current-extension-compiler-flags))) 
  (current-extension-linker-flags
   (cons "/Zi" (current-extension-linker-flags)))) 

(for-each 
 (lambda (src obj) 
   (compile-extension #f src obj null)) 
 srcs objs) 

(define dir (build-path "collects"
                        spico-name
                        "compiled" 
                        "native" 
                        (system-library-subpath)))

(make-directory* dir)

(link-extension #f objs (build-path dir (append-extension-suffix "spico-eval")))

(for-each (lambda (filename)
            (copy-file filename (build-path "collects" spico-name filename)))
          extra-sources)

(pack spico-plt
      spico-name
      (cons (build-path dir (append-extension-suffix "spico-eval"))
            (map (lambda (filename)
                   (build-path "collects" spico-name filename))
                 extra-sources))
      `((,spico-name))
      void #t 'file-replace #f #t '() '() #f)

(delete-directory/files "collects")
;(when install?
; (run-installer spico-plt))
